TypeElement (Java Platform SE 8 )
Keywords: javax.lang.model.element.TypeElement interface
Date: 2026-04-17

compact3
javax.lang.model.element

## Interface TypeElement

- All Superinterfaces:
    AnnotatedConstruct, Element, Parameterizable, QualifiedNameable

      public interface TypeElement
      extends Element, Parameterizable, QualifiedNameable

  Represents a class or interface program element. Provides access to information about the type and its members. Note that an enum type is a kind of class and an annotation type is a kind of interface.

  While a `TypeElement` represents a class or interface element, a `DeclaredType` represents a class or interface type, the latter being a use (or invocation) of the former. The distinction is most apparent with generic types, for which a single element can define a whole family of types. For example, the element `java.util.Set` corresponds to the parameterized types `java.util.Set<String>` and `java.util.Set<Number>` (and many others), and to the raw type `java.util.Set`.

  Each method of this interface that returns a list of elements will return them in the order that is natural for the underlying source of program information. For example, if the underlying source of information is Java source code, then the elements will be returned in source code order.

  Since:
    1.6
  See Also:
    `DeclaredType`

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `List<? extends Element>` | `getEnclosedElements()` Returns the fields, methods, constructors, and member types that are directly declared in this class or interface.
    `Element` | `getEnclosingElement()` Returns the package of a top-level type and returns the immediately lexically enclosing element for a nested type.
    `List<? extends TypeMirror>` | `getInterfaces()` Returns the interface types directly implemented by this class or extended by this interface.
    `NestingKind` | `getNestingKind()` Returns the nesting kind of this type element.
    `Name` | `getQualifiedName()` Returns the fully qualified name of this type element.
    `Name` | `getSimpleName()` Returns the simple name of this type element.
    `TypeMirror` | `getSuperclass()` Returns the direct superclass of this type element.
    `List<? extends TypeParameterElement>` | `getTypeParameters()` Returns the formal type parameters of this type element in declaration order.

    - ### Methods inherited from interface javax.lang.model.element.Element

      `accept, asType, equals, getAnnotation, getAnnotationMirrors, getKind, getModifiers, hashCode`

    - ### Methods inherited from interface javax.lang.model.AnnotatedConstruct

      `getAnnotationsByType`

- - ### Method Detail

    - #### getEnclosedElements

          List<? extends Element> getEnclosedElements()

      Returns the fields, methods, constructors, and member types that are directly declared in this class or interface. This includes any (implicit) default constructor and the implicit `values` and `valueOf` methods of an enum type.

      Note that as a particular instance of the general accuracy requirements and the ordering behavior required of this interface, the list of enclosed elements will be returned in the natural order for the originating source of information about the type. For example, if the information about the type is originating from a source file, the elements will be returned in source code order. (However, in that case the the ordering of synthesized elements, such as a default constructor, is not specified.)

      Specified by:
        `getEnclosedElements` in interface `Element`
      Returns:
        the enclosed elements in proper order, or an empty list if none
      See Also:
        `PackageElement.getEnclosedElements()`, `getEnclosedElements()`, `Elements.getAllMembers(javax.lang.model.element.TypeElement)`

    - #### getNestingKind

          NestingKind getNestingKind()

      Returns the nesting kind of this type element.
      Returns:
        the nesting kind of this type element

    - #### getQualifiedName

          Name getQualifiedName()

      Returns the fully qualified name of this type element. More precisely, it returns the canonical name. For local and anonymous classes, which do not have canonical names, an empty name is returned.

      The name of a generic type does not include any reference to its formal type parameters. For example, the fully qualified name of the interface `java.util.Set<E>` is "`java.util.Set`". Nested types use "`.`" as a separator, as in "`java.util.Map.Entry`".

      Specified by:
        `getQualifiedName` in interface `QualifiedNameable`
      Returns:
        the fully qualified name of this class or interface, or an empty name if none
      See Also:
        `Elements.getBinaryName(javax.lang.model.element.TypeElement)`
      See The Java™ Language Specification:
        6.7 Fully Qualified Names and Canonical Names

    - #### getSimpleName

          Name getSimpleName()

      Returns the simple name of this type element. For an anonymous class, an empty name is returned.
      Specified by:
        `getSimpleName` in interface `Element`
      Returns:
        the simple name of this class or interface, an empty name for an anonymous class
      See Also:
        `PackageElement.getSimpleName()`, `ExecutableElement.getSimpleName()`, `getSimpleName()`, `VariableElement.getSimpleName()`

    - #### getSuperclass

          TypeMirror getSuperclass()

      Returns the direct superclass of this type element. If this type element represents an interface or the class `java.lang.Object`, then a `NoType` with kind `NONE` is returned.
      Returns:
        the direct superclass, or a `NoType` if there is none

    - #### getInterfaces

          List<? extends TypeMirror> getInterfaces()

      Returns the interface types directly implemented by this class or extended by this interface.
      Returns:
        the interface types directly implemented by this class or extended by this interface, or an empty list if there are none

    - #### getTypeParameters

          List<? extends TypeParameterElement> getTypeParameters()

      Returns the formal type parameters of this type element in declaration order.
      Specified by:
        `getTypeParameters` in interface `Parameterizable`
      Returns:
        the formal type parameters, or an empty list if there are none

    - #### getEnclosingElement

          Element getEnclosingElement()

      Returns the package of a top-level type and returns the immediately lexically enclosing element for a nested type.
      Specified by:
        `getEnclosingElement` in interface `Element`
      Returns:
        the package of a top-level type, the immediately lexically enclosing element for a nested type
      See Also:
        `Elements.getPackageOf(javax.lang.model.element.Element)`

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.
Copyright © 1993, 2026, Oracle and/or its affiliates. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.